Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: REQUIRED | OPTIONAL | DETAIL: ELEMENT

## javax.persistence
Annotation Type MapKeyJoinColumn

    @Target(value={METHOD,FIELD})
    @Retention(value=RUNTIME)
    public @interface MapKeyJoinColumn

Specifies a mapping to an entity that is a map key. The map key join column is in the collection table, join table, or table of the target entity that is used to represent the map. If no `MapKeyJoinColumn` annotation is specified, a single join column is assumed and the default values apply.

        Example 1:

        @Entity
        public class Company {
           @Id int id;
           ...
           @OneToMany   // unidirectional
           @JoinTable(name="COMPANY_ORGANIZATION",
                      joinColumns=@JoinColumn(name="COMPANY"),
                      inverseJoinColumns=@JoinColumn(name="VICEPRESIDENT"))
           @MapKeyJoinColumn(name="DIVISION")
           Map<Division, VicePresident> organization;
        }

        Example 2:

        @Entity
        public class VideoStore {
           @Id int id;
           String name;
           Address location;
           ...
           @ElementCollection
           @CollectionTable(name="INVENTORY",
                            joinColumns=@JoinColumn(name="STORE"))
           @Column(name="COPIES_IN_STOCK")
           @MapKeyJoinColumn(name="MOVIE", referencedColumnName="ID")
           Map<Movie, Integer> videoInventory;
           ...
         }

         @Entity
         public class Movie {
            @Id long id;
            String title;
            ...
         }

         Example 3:

         @Entity
         public class Student {
            @Id int studentId;
            ...
            @ManyToMany  // students and courses are also many-many
            @JoinTable(name="ENROLLMENTS",
                       joinColumns=@JoinColumn(name="STUDENT"),
                       inverseJoinColumns=@JoinColumn(name="SEMESTER"))
            @MapKeyJoinColumn(name="COURSE")
            Map<Course, Semester>  enrollment;
            ...
         }

Since:
  Java Persistence 2.0

Optional Element Summary
`java.lang.String` | `columnDefinition` (Optional) The SQL fragment that is used when generating the DDL for the column.
`boolean` | `insertable` (Optional) Whether the column is included in SQL INSERT statements generated by the persistence provider.
`java.lang.String` | `name` (Optional) The name of the foreign key column for the map key.
`boolean` | `nullable` (Optional) Whether the foreign key column is nullable.
`java.lang.String` | `referencedColumnName` (Optional) The name of the column referenced by this foreign key column.
`java.lang.String` | `table` (Optional) The name of the table that contains the foreign key column.
`boolean` | `unique` (Optional) Whether the property is a unique key.
`boolean` | `updatable` (Optional) Whether the column is included in SQL UPDATE statements generated by the persistence provider.

### name

    public abstract java.lang.String name

  (Optional) The name of the foreign key column for the map key. The table in which it is found depends upon the context.
  - If the join is for a map key for an element collection, the foreign key column is in the collection table for the map value.
  - If the join is for a map key for a ManyToMany entity relationship or for a OneToMany entity relationship using a join table, the foreign key column is in a join table.
  - If the join is for a OneToMany entity relationship using a foreign key mapping strategy, the foreign key column for the map key is in the table of the entity that is the value of the map.

  Default (only applies if a single join column is used.) The concatenation of the following: the name of the referencing relationship property or field of the referencing entity or embeddable class; "_"; "KEY".

  Default:
    ""

### referencedColumnName

    public abstract java.lang.String referencedColumnName

  (Optional) The name of the column referenced by this foreign key column. The referenced column is in the table of the target entity.

  Default (only applies if single join column is being used.) The same name as the primary key column of the referenced table

  Default:
    ""

### unique

    public abstract boolean unique

  (Optional) Whether the property is a unique key. This is a shortcut for the `UniqueConstraint` annotation at the table level and is useful for when the unique key constraint is only a single field.

  Default:
    false

### nullable

    public abstract boolean nullable

  (Optional) Whether the foreign key column is nullable.

  Default:
    false

### insertable

    public abstract boolean insertable

  (Optional) Whether the column is included in SQL INSERT statements generated by the persistence provider.

  Default:
    true

### updatable

    public abstract boolean updatable

  (Optional) Whether the column is included in SQL UPDATE statements generated by the persistence provider.

  Default:
    true

### columnDefinition

    public abstract java.lang.String columnDefinition

  (Optional) The SQL fragment that is used when generating the DDL for the column. Defaults to SQL generated by the provider for the column.

  Default:
    ""

### table

    public abstract java.lang.String table

  (Optional) The name of the table that contains the foreign key column.
  - If the join is for a map key for an element collection, the foreign key column is in the collection table for the map value.
  - If the join is for a map key for a ManyToMany entity relationship or for a OneToMany entity relationship using a join table, the foreign key column is in a join table.
  - If the join is for a OneToMany entity relationship using a foreign key mapping strategy, the foreign key column for the map key is in the table of the entity that is the value of the map.

  Default:

  - If the map is for an element collection, the name of the collection table for the map value.
  - If the map is for a OneToMany or ManyToMany entity relationship using a join table, the name of the join table for the map.
  - If the map is for a OneToMany entity relationship using a foreign key mapping strategy, the name of the primary table of the entity that is the value of the map.

  Default:
    ""

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: REQUIRED | OPTIONAL | DETAIL: ELEMENT